// Starsi zak  04
unit main;
{Probhn ve stromu se lze za pomoc Double Clicku na seznam}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Menus, StdCtrls;

type
  TFMain = class(TForm)
    MainMenu1: TMainMenu;
    Program1: TMenuItem;
    Konec1: TMenuItem;
    Osoba1: TMenuItem;
    Pidatosobu1: TMenuItem;
    Odebratosobu1: TMenuItem;
    StatusBar1: TStatusBar;
    seznam: TListBox;
    Nastzesouboru1: TMenuItem;
    Uloitdosouboru1: TMenuItem;
    OpenDialog1: TOpenDialog;
    Upravit1: TMenuItem;
    Zobrazit1: TMenuItem;
    vechnajmna1: TMenuItem;
    SaveDialog1: TSaveDialog;
    vybranosoba1: TMenuItem;
    N1: TMenuItem;
    propojitpartnerypodledt1: TMenuItem;
    vbrpartnera1: TMenuItem;
    Slouit1: TMenuItem;
    procedure Konec1Click(Sender: TObject);
    procedure Pidatosobu1Click(Sender: TObject);
    procedure seznamDrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
    procedure seznamDblClick(Sender: TObject);
    procedure Nastzesouboru1Click(Sender: TObject);
    procedure Odebratosobu1Click(Sender: TObject);
    procedure Upravit1Click(Sender: TObject);
    procedure vechnajmna1Click(Sender: TObject);
    procedure Uloitdosouboru1Click(Sender: TObject);
    procedure vybranosoba1Click(Sender: TObject);
    procedure propojitpartnerypodledt1Click(Sender: TObject);
    procedure vbrpartnera1Click(Sender: TObject);
    procedure Slouit1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure ZobrazVse;
    procedure ZobrazOsobu(index: integer);
    procedure PropojPartnery;
  end;
  TOsoba=class
    ID: integer;
    id2: string;
    Jmeno,Prijmeni: String;
    Pohlavi: (PoMuz,PoZena);
    Narozeni,Umrti: String;
    Matka: TOsoba;
    matkaID: string;
    Otec: TOsoba;
    otecID: string;
    Partneri: tstringlist;
    constructor Create;
    destructor free;
  end;

var
  FMain: TFMain;
  Lide: Tlist;

implementation

uses osobaunit, vyberunit;

{$R *.DFM}

constructor TOsoba.Create;
begin
  partneri:=tstringlist.create;
end;

destructor TOsoba.free;
begin
  partneri.clear;
  partneri.free;
end;

procedure TFMain.Konec1Click(Sender: TObject);
begin
  close;
end;

procedure TFMain.Pidatosobu1Click(Sender: TObject);
var dlg: TFOsoba;
    osoba: tosoba;

begin
  dlg:=tfosoba.create(self);
  try
    dlg.ShowModal;

    with dlg do
    if okclicked then with osoba do begin
      osoba:=tosoba.create;
      ID:=lide.count;
      jmeno:=edjmeno.text;
      prijmeni:=edprijmeni.text;
      case rgpohlavi.itemindex of
        0: pohlavi:=PoMuz;
        1: pohlavi:=poZena;
      end;
      narozeni:=ednarozeni.text;
      umrti:=edumrti.text;
      if comatka.itemindex>0 then matka:=tosoba(lide[strtoint(comatka.items[comatka.itemindex])]) else
       matka:=nil;
      if cootec.itemindex>0 then otec:=tosoba(lide[strtoint(cootec.items[cootec.itemindex])]) else
        otec:=nil;
        partneri.Assign(lbpartneri.items);
      lide.add(osoba);
    end;
    ZobrazVse;
  finally
    dlg.free;
  end;
end;

procedure TFmain.ZobrazVse;
var i: integer;
begin
  seznam.clear;
  seznam.tag:=0; //Jenom zobrazeni jmen
  seznam.items.beginupdate;
  for i:=0 to lide.count-1 do seznam.items.add(inttostr(tosoba(lide[i]).id));
  seznam.items.endupdate;
  statusbar1.simpletext:='vechny osoby';
end;

procedure TFMain.seznamDrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);

{Zobrazeni jmeno pomoci ID}
var cl: tcolor;
    s,znak,jmeno: string;
begin
  if odselected in state then cl:=clnavy else cl:=clwhite;
  seznam.canvas.brush.color:=cl;
  seznam.canvas.pen.color:=cl;
  seznam.canvas.rectangle(rect);
  case seznam.tag of
    0: s:=tosoba(lide[strtoint(seznam.items[index])]).jmeno+' '+tosoba(lide[strtoint(seznam.items[index])]).prijmeni;
    1: begin
      s:=seznam.items[index];
      znak:=copy(s,1,1);
      s:=copy(s,2,length(s)-1);
      jmeno:=tosoba(lide[strtoint(s)]).jmeno+' '+tosoba(lide[strtoint(s)]).prijmeni;
      case znak[1] of
        'p': s:='manel/ka: '+jmeno;
        'd': s:='dt: '+jmeno;
        'm': s:='matka: '+jmeno;
        'o': s:='otec: '+jmeno;
        'D': s:='praotec: '+jmeno;
        'B': s:='pramatka: '+jmeno;
        'v': s:='vnoue: '+jmeno;
      end;
    end;
  end;
  seznam.canvas.textout(rect.left,rect.top,s);
end;

procedure TFMain.ZobrazOsobu;
{Zobrazi podpolozky urcene osoby}
var i: integer;
    os: tosoba;
begin
  seznam.clear;
  seznam.tag:=1; //zobrazeni s popisem
  seznam.items.beginupdate;
  os:=lide[index];
  with os do begin
    {partneri}
    for i:=0 to partneri.count-1 do seznam.items.add('p'+partneri[i]);
    {deti}
    for i:=0 to lide.count-1 do begin
      if pohlavi=pozena then if tosoba(lide[i]).matka=os then seznam.items.add('d'+inttostr(i));
      if pohlavi=pomuz then if tosoba(lide[i]).otec=os then seznam.items.add('d'+inttostr(i));
    end;
    {rodice}
    if matka<>nil then seznam.items.add('m'+inttostr(matka.id));
    if otec<>nil then seznam.items.add('o'+inttostr(otec.id));
    {prarodice}
    if (matka<>nil)then if (matka.matka<>nil) then seznam.items.add('B'+inttostr(matka.matka.id));
    if (otec<>nil)then if (otec.matka<>nil) then seznam.items.add('B'+inttostr(otec.matka.id));
    if (matka<>nil)then if (matka.otec<>nil) then seznam.items.add('D'+inttostr(matka.otec.id));
    if (otec<>nil)then if (otec.otec<>nil) then seznam.items.add('D'+inttostr(otec.otec.id));
    {vnoucata}
    for i:=0 to lide.count-1 do with tosoba(lide[i]) do begin
      if (matka<>nil)then if (matka.matka=os) then seznam.items.add('v'+inttostr(tosoba(lide[i]).id));
      if (otec<>nil)then if (otec.matka=os) then seznam.items.add('v'+inttostr(tosoba(lide[i]).id));
      if (matka<>nil)then if (matka.otec=os) then seznam.items.add('v'+inttostr(tosoba(lide[i]).id));
      if (otec<>nil)then if (otec.otec=os) then seznam.items.add('v'+inttostr(tosoba(lide[i]).id));
    end;
  end;
  seznam.items.endupdate;
end;

procedure TFMain.seznamDblClick(Sender: TObject);
var s: string;
begin
  s:=seznam.items[seznam.itemindex];
  if seznam.tag=1 then s:=copy(s,2,length(s)-1);
  zobrazosobu(strtoint(s));
  statusbar1.simpletext:=tosoba(lide[strtoint(s)]).jmeno+' '+tosoba(lide[strtoint(s)]).prijmeni;
end;

function GetNextTagName(var s: string): string;
var a: integer;
    start,cil: integer;
begin
  for a:=1 to length(s) do begin
    if s[a]='<' then start:=a;
    if s[a]='>' then begin
      cil:=a;
      break;
    end;
  end;
  result:=copy(s,start,cil-start+1);
  delete(s,1,cil);
end;

function GetNextTagValue(var s: string): string;
var a: integer;
    cil: integer;
begin
  for a:=1 to length(s) do begin
    if s[a]='<' then begin
      cil:=a;
      break;
    end;
  end;
  result:=copy(s,1,cil-1);
  delete(s,1,cil-1);
end;

procedure TFMain.Nastzesouboru1Click(Sender: TObject);
{Nacitani rodokmenu ze souboru}
var str: tstringlist;
    intag,mezitagy: boolean;
    a,b: integer;
    s,tg: string;
    docstart: boolean;
    osoba: tosoba;
begin
  intag:=false;
  mezitagy:=false;
  if opendialog1.execute then begin
    lide.clear;
    statusbar1.simpletext:='Nahravam...';
    str:=tstringlist.create;
    try
      str.loadfromfile(opendialog1.filename);
      s:=str.text;
      docstart:=false;
      while (tg<>'</RODOKMEN>')and(s<>'') do begin
        tg:=uppercase(getnexttagname(s));
        if tg='<RODOKMEN>' then docstart:=true;
        if docstart then begin
          if tg='<OSOBA>' then osoba:=tosoba.create;
          if tg='</OSOBA>' then lide.add(osoba);
          if tg='<ID>' then osoba.id2:=getnexttagvalue(s);
          if tg='<JMENO>' then osoba.jmeno:=getnexttagvalue(s);
          if tg='<PRIJMENI>' then osoba.prijmeni:=getnexttagvalue(s);
          if tg='<POHLAVI>' then if uppercase(getnexttagvalue(s))='M' then osoba.pohlavi:=PoMuz
           else osoba.pohlavi:=poZena;
          if tg='<NAROZENI>' then osoba.narozeni:=getnexttagvalue(s);
          if tg='<UMRTI>' then osoba.umrti:=getnexttagvalue(s);
          if tg='<OTEC>' then osoba.otecid:=getnexttagvalue(s);
          if tg='<MATKA>' then osoba.matkaid:=getnexttagvalue(s);
        end;
      end;
      //Propojeni dat pomoci ID, zavedeni vlastnich id
      for a:=0 to lide.count-1 do begin
        for b:=0 to lide.count-1 do begin
          with tosoba(lide[b]) do begin
            if otecid=tosoba(lide[a]).id2 then otec:=lide[a];
            if matkaid=tosoba(lide[a]).id2 then matka:=lide[a];
          end;
        end;
        tosoba(lide[a]).id:=a;
      end;
      propojpartnery;
    finally
      str.free;
    end;
    ZobrazVse;
    statusbar1.simpletext:='';
  end;
end;

procedure TFMain.PropojPartnery;
var i: integer;
begin
  //vymazani vsech vztahu
  for i:=0 to lide.count-1 do tosoba(lide[i]).partneri.clear;
  //propojeni vztahu
  for i:=0 to lide.count-1 do with tosoba(lide[i]) do begin
    if (matka<>nil)and(otec<>nil) then begin
      if matka.partneri.indexof(inttostr(otec.id))=-1 then
        matka.partneri.add(inttostr(otec.id));
      if otec.partneri.indexof(inttostr(matka.id))=-1 then
        otec.partneri.add(inttostr(matka.id));
    end;
  end;
end;

procedure TFMain.Odebratosobu1Click(Sender: TObject);
var i: integer;
begin
  if seznam.itemindex<>0 then begin
    for i:=0 to lide.count-1 do if seznam.items[seznam.itemindex]=inttostr(tosoba(lide[i]).id)
     then break;
    seznam.items.delete(seznam.itemindex);
    lide.Delete(i);
  end;

end;

procedure TFMain.Upravit1Click(Sender: TObject);
var dlg: tfosoba;
    i: integer;
begin
  if seznam.itemindex<>-1 then
  try
    dlg:=tfosoba.create(self);
    if seznam.tag=0 then i:=strtoint(seznam.items[seznam.itemindex])
     else i:=strtoint(copy(seznam.items[seznam.itemindex],2,length(seznam.items[seznam.itemindex])-1));
    with tosoba(lide[i]) do with dlg do begin
      edjmeno.text:=jmeno;
      edprijmeni.text:=prijmeni;
      rgpohlavi.itemindex:=ord(pohlavi=pozena);
      ednarozeni.text:=narozeni;
      edumrti.text:=umrti;
      if matka<>nil then comatka.itemindex:=comatka.items.indexof(inttostr(matka.id));
      if otec<>nil then cootec.itemindex:=cootec.items.indexof(inttostr(otec.id));
      lbpartneri.items.assign(partneri);
    end;
    dlg.showmodal;
  finally
    dlg.free;
  end;
end;

procedure TFMain.vechnajmna1Click(Sender: TObject);
begin
  zobrazvse;
end;

procedure TFMain.Uloitdosouboru1Click(Sender: TObject);
var t: textfile;
    i: integer;

const sex: array[poMuz..poZena]of char='MZ';
begin
  if savedialog1.execute then begin
    assignfile(t,savedialog1.filename);
    rewrite(t);
    writeln(t,'<rodokmen>');
    for i:=0 to lide.count-1 do with tosoba(lide[i]) do begin
      writeln(t,'  <osoba>');
      writeln(t,'    <id>',id,'</id>');
      writeln(t,'    <jmeno>',jmeno,'</jmeno>');
      writeln(t,'    <prijmeni>',prijmeni,'</prijmeni>');
      writeln(t,'    <pohlavi>',sex[pohlavi],'</pohlavi>');
      writeln(t,'    <narozeni>',narozeni,'</narozeni>');

      if umrti<>'' then writeln(t,'    <umrti>',umrti,'</umrti>')
       else writeln(t,'    <umrti/>');

      if matka<>nil then writeln(t,'    <matka>',matka.id,'</matka>')
       else writeln(t,'    <matka/>');
      if otec<>nil then writeln(t,'    <otec>',otec.id,'</otec>')
       else writeln(t,'    <otec/>');

      writeln(t,'  </osoba>');
    end;
    writeln(t,'</rodokmen>');
    closefile(t);
  end;
end;

procedure TFMain.vybranosoba1Click(Sender: TObject);
begin
  if seznam.itemindex<>-1 then
    seznamdblclick(self);
end;

procedure TFMain.propojitpartnerypodledt1Click(Sender: TObject);
begin
  propojpartnery;
end;

procedure TFMain.vbrpartnera1Click(Sender: TObject);
begin
  if seznam.itemindex<>-1 then
  fvyber.showmodal;
end;

procedure TFMain.Slouit1Click(Sender: TObject);
{Nacitani rodokmenu ze souboru}
var str: tstringlist;
    intag,mezitagy: boolean;
    a,b: integer;
    s,tg: string;
    docstart: boolean;
    osoba: tosoba;
begin
  intag:=false;
  mezitagy:=false;
  if opendialog1.execute then begin
    statusbar1.simpletext:='Nahravam...';
    str:=tstringlist.create;
    try
      str.loadfromfile(opendialog1.filename);
      s:=str.text;
      docstart:=false;
      while (tg<>'</RODOKMEN>')and(s<>'') do begin
        tg:=uppercase(getnexttagname(s));
        if tg='<RODOKMEN>' then docstart:=true;
        if docstart then begin
          if tg='<OSOBA>' then osoba:=tosoba.create;
          if tg='</OSOBA>' then lide.add(osoba);
          if tg='<ID>' then osoba.id2:=getnexttagvalue(s);
          if tg='<JMENO>' then osoba.jmeno:=getnexttagvalue(s);
          if tg='<PRIJMENI>' then osoba.prijmeni:=getnexttagvalue(s);
          if tg='<POHLAVI>' then if uppercase(getnexttagvalue(s))='M' then osoba.pohlavi:=PoMuz
           else osoba.pohlavi:=poZena;
          if tg='<NAROZENI>' then osoba.narozeni:=getnexttagvalue(s);
          if tg='<UMRTI>' then osoba.umrti:=getnexttagvalue(s);
          if tg='<OTEC>' then osoba.otecid:=getnexttagvalue(s);
          if tg='<MATKA>' then osoba.matkaid:=getnexttagvalue(s);
        end;
      end;
      //Propojeni dat pomoci ID, zavedeni vlastnich id
      for a:=0 to lide.count-1 do begin
        for b:=0 to lide.count-1 do begin
          with tosoba(lide[b]) do begin
            if otecid=tosoba(lide[a]).id2 then otec:=lide[a];
            if matkaid=tosoba(lide[a]).id2 then matka:=lide[a];
          end;
        end;
        tosoba(lide[a]).id:=a;
      end;
      propojpartnery;
    finally
      str.free;
    end;
    ZobrazVse;
    statusbar1.simpletext:='';
  end;

end;

initialization
  lide:=tlist.create;

finalization
  lide.clear;
  lide.free;

end.

