// Starsi zak  04
unit vyberunit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TFVyber = class(TForm)
    edhodnota: TEdit;
    Label1: TLabel;
    Button1: TButton;
    lbJmeno: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FVyber: TFVyber;
  tabulka: tstringlist;
  {do ni budeme ukladat pocty bodu jednotlivych kandidatu}

implementation

uses main;

var osoba: tosoba;

{$R *.DFM}

function JePraRodic(pra,vno: tosoba): boolean;
begin
  result:=false;
  with vno do begin
    if (matka<>nil)then if (matka.matka=pra) then result:=true;
    if (otec<>nil)then if (otec.matka=pra) then result:=true;
    if (matka<>nil)then if (matka.otec=pra) then result:=true;
    if (otec<>nil)then if (otec.otec=pra) then result:=true;
  end;
end;

function JeRodic(pra,dit: tosoba): boolean;
begin
  result:=false;
  with dit do begin
    if (matka=pra)then result:=true;
    if (otec=pra)then result:=true;
  end;
end;

function JeSourozenec(s1,s2: tosoba): boolean;
begin
  result:=(s1.matka=s2.matka)or(s1.otec=s2.otec);
end;

procedure TFVyber.Button1Click(Sender: TObject);
var maxrozdil: integer;
    kandidat: tosoba;
    i,body,poloha: integer;
begin
  body:=0;
  maxrozdil:=strtoint(edhodnota.text);
  for i:=0 to lide.count-1 do begin
    kandidat:=lide[i];
    if kandidat=osoba then body:=-2000;
    if kandidat.pohlavi=osoba.pohlavi then body:=-1000;
    if (jerodic(kandidat,osoba))or(jerodic(osoba,kandidat))or
       (jeprarodic(kandidat,osoba))or(jeprarodic(osoba,kandidat))
        then body:=-1000;
    if kandidat.umrti<>'' then body:=-1000;//mrtvi partner neni uplne vhodny !
    if jesourozenec(osoba,kandidat) then body:=-1000;
    if kandidat.narozeni='' then kandidat.narozeni:='0';
    if osoba.narozeni='' then osoba.narozeni:='0';
    body:=body-abs(strtoint(kandidat.narozeni)-strtoint(osoba.narozeni));
    tabulka.add(inttostr(body));
  end;
  body:=-2000;
  poloha:=-1;
  for i:=0 to tabulka.count-1 do if strtoint(tabulka[i])>body then begin
    body:=strtoint(tabulka[i]);
    poloha:=i;
  end;
  if poloha=-1 then showmessage('Nebyl nalezen dn vhodn partner !') else begin
    kandidat:=lide[poloha];
    if application.messagebox(pchar(kandidat.jmeno+' '+kandidat.prijmeni+' je nejvhodnj partner'+#13+
    'm se provst propojen ?'),'Nalezeno !',mb_iconquestion+mb_yesno)=idyes then begin
      kandidat.partneri.add(inttostr(osoba.id));
      osoba.partneri.add(inttostr(kandidat.id));
    end;
  end;
  close;
end;

procedure TFVyber.FormShow(Sender: TObject);
var s: string;
begin
  tabulka.clear;
  s:=fmain.seznam.items[fmain.seznam.itemindex];
  if fmain.seznam.tag=1 then s:=copy(s,2,length(s)-1);
  osoba:=lide[strtoint(s)];
  lbjmeno.caption:=osoba.jmeno+' '+osoba.prijmeni;
end;

initialization
  tabulka:=tstringlist.create;

finalization
  tabulka.free;

end.
